<?php
class LOTD extends DataObject implements PermissionProvider {
    static $db = array(
	 'LName' => 'Text',
	 'Opis' => 'Text',
        'LOTD' => 'Text'
    );

    static $default_parent = "LOTDPage";

    static $has_one = array(
	'LOTDPage' => 'LOTDPage',
    );

    static $default_sort = "LName ASC";

    static $searchable_fields = array(
      'LName',
      'Opis'
    );
   
    static $search_heading = "LName";
    static $search_content = "Opis";
    
    static $indexes = array(
      "SearchFields" => "fulltext (LName, Opis)",
      "TitleSearchFields" => "fulltext (LName)"
    );
   
    public function Title() {
      return DBField::create('Text',$this->record['Title']);
    }

    public function Content() {
      return DBField::create('Text',$this->record['Content']);
    }

    public function canView() {return true;}
   
    public function Link() {
      return DataObject::get_one("LOTDPage")->Link() ."#term".$this->ID;
    } 

    function providePermissions() {
            return array(
		"ADDLOTD" => array(
                        'name' => _t($this->class . '.ADDLOTD', ' Korisnik moze dodati LOTD'),
                        'category' => _t($this->class . '.LOTD_CATEGORY', 'Ovlasti za LOTD'),
                        'help' => _t($this->class . 'ADDLOTD_HELP', 'Korisnik moze dodati Link Of The Day'),
                        'sort' => 1
	       ),
		"DELLOTD" => array(
                        'name' => _t($this->class . '.DELLOTD', ' Korisnik moze obrisati LOTD'),
                        'category' => _t($this->class . '.LOTD_CATEGORY', 'Ovlasti za LOTD'),
                        'help' => _t($this->class . 'DELLOTD_HELP', 'Korisnik moze obrisati Link Of The Day'),
                        'sort' => 1
	       ),
		"EDITLOTD" => array(
                        'name' => _t($this->class . '.EDITLOTD', ' Korisnik moze izmijenit LOTD'),
                        'category' => _t($this->class . '.LOTD_CATEGORY', 'Ovlasti za LOTD'),
                        'help' => _t($this->class . 'EDITLOTD_HELP', 'Korisnik moze izmijenit Link Of The Day'),
                        'sort' => 1
	       )
	     );

    }


	function EditURL() {
		return $this->CurrentPage()->Link('post') . '/' . $this->ID . '/';
	}

	function NewURL() {
		return $this->CurrentPage()->Link('post') . '/';
	}


	function canAddLOTD($member = null){
		if (($member == null)||($member == 0)) return false;
		return (Permission::checkMember($member, 'ADDLOTD'));
	}

	function canDelLOTD($member = null){
		if (($member == null)||($member == 0)) return false;
		return (Permission::checkMember($member, 'DELLOTD'));
	}

	function canEditLOTD($member = null){
		if (($member == null)||($member == 0)) return false;
		return (Permission::checkMember($member, 'EDITLOTD'));
	}

        function delURL(){
                return $this->CurrentPage()->Link() . 'delLOTD' . '/' . $this->ID . '/';
        }

        function delLOTD($request) {
                $param = $request->allParams();
                $dL = DataObject::get_by_id('LOTD',(int)$param['ID']);
                $dL->delete();
                $this->redirect('.');
        }

}
